var Ped14000_parametrosWebservice_Controller = function(Ped14000_parametrosWebservice_Service, ScreenService, templateManager, Endereco, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService){
    
    this.openFilter = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
    };
    this.disableField = function(){
        var widget = templateManager.container.getActiveWidget();
        
        if (widget.currentRow.NRSEQWEBSERVICE != ""){
            widget.getField('NRSEQWEBSERVICE').readOnly = true;
        }else{
            widget.getField('NRSEQWEBSERVICE').readOnly = false;
        }
    };
    
    this.salvaTabelasCliente = function(widget){
        
        var data = {};
        
        var row = {};
        
        if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTCLIE: widget.currentRow.DTULTALTCLIE,
                    DTULTATUCLIE: widget.currentRow.DTULTATUCLIE,
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row);
            
                ScreenService.showMessage('Cliente salvo com sucesso.');
                ScreenService.closeSwipe();
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Cliente já cadastrado neste Webserice.');
                ScreenService.closeSwipe();
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosCliePedWeb(data).then(function(success){
                
                row[0]={
                    CDCLIENTE: widget.currentRow.CDCLIENTE,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTCLIE: widget.currentRow.DTULTALTCLIE,
                    DTULTATUCLIE: widget.currentRow.DTULTATUCLIE,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosClieWebSync(row);
                
                ScreenService.showMessage('Cliente editado com sucesso.');
                ScreenService.closeSwipe();
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Cliente já cadastrado neste Webserice.');
                ScreenService.closeSwipe();
                widget.reload();
                
            }.bind(this));
        }
    };
    
    this.validaCodigoSiteProd = function(widget){
        var codProdSite =widget.currentRow.CDPRODEXTERNO;
    
        var filter = [
            {
                "name": "CDPRODEXTERNO",
                "operator": "=",
                "value": widget.currentRow.CDPRODEXTERNO
            }
            
        ];
        
        General.callRestEngine('ped#/crud/prodpedweb', 'FilterData', filter).then(function(callback){
            var codigos= callback.dataset.prodpedweb;
            var found = codigos.find(element=>element.CDPRODEXTERNO == codProdSite);

                if(found != undefined){
                    var continuar_msg = ScreenService.i18n("O código do site informado já está relacionado a outro produto. Deseja continuar?");
                    ScreenService.showCustomDialog(continuar_msg, 'question', 'question', [{
                    label: ScreenService.i18n("Sim"),
                    code: function(){
                        this.salvaTabelasProduto(widget);
                    }.bind(this)
                    },{
                        label: ScreenService.i18n("Não"),
                        code: function(){}.bind(this)
                    }]);
                        
                }else{
                    this.salvaTabelasProduto(widget);
                }
        }.bind(this));           

    };
    
    this.salvaTabelasProduto = function(widget){
        var data = {};
         if(widget.currentRow.__is_new){
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                var row = {};
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row);
            
                ScreenService.showMessage('Produto salvo com sucesso.');
                ScreenService.closeSwipe();
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível adicionar. Produto já cadastrado.');
                ScreenService.closeSwipe();
                widget.reload();
                
            }.bind(this));
        }else{
            data[0]= widget.currentRow;
            Ped14000_parametrosWebservice_Service.salvaDadosProdPedWeb(data).then(function(success){
                var row = {};
                
                row[0]={
                    CDPRODUTO: widget.currentRow.CDPRODUTO,
                    NRSEQWEBSERVICE: widget.currentRow.NRSEQWEBSERVICE,
                    IDATUALIZADO: widget.currentRow.IDATUALIZADO,
                    DTULTALTPROD: widget.currentRow.DTULTALTPROD,
                    DTULTATUPROD: widget.currentRow.DTULTATUPROD,
                    __is_new:false,
                    changed:true
                };
                Ped14000_parametrosWebservice_Service.salvaDadosProdWebSync(row);
                
                ScreenService.showMessage('Produto editado com sucesso.');
                ScreenService.closeSwipe();
                
            }.bind(this)).catch(function(fail){
                ScreenService.showMessage('Impossível editar. Produto já cadastrado.');
                ScreenService.closeSwipe();
                widget.reload();
                
            }.bind(this));
        }
    };
};  
    Configuration(function(ContextRegister){
    ContextRegister.register('Ped14000_parametrosWebservice_Controller', Ped14000_parametrosWebservice_Controller);
});