
function tabelaDesconto() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Pedidos', 'Tabela de Desconto']);
		geral.esperarLoading();
	};

	this.adicionarTipoDesconto = (nome, situacao, tipoDesconto, desconto) => {
		geral.clickAdicionar();
		geral.clickAndFllField('NMTABDESC', nome);
		geral.selectNative('IDSITTABDESC', situacao);
		geral.selectNative('IDTIPODESC', tipoDesconto);
		if (tipoDesconto == 'Fixo') {
			geral.fillField('VRPERDESC', desconto);
		}
		geral.clickSalvar();
	};

	this.editarDescontoProduto = (produtoInicial, produtoFinal, produto, descontoProdutoGridId, desconto) => {
		geral.searchAndClickGridField('NMPRODINI', produtoInicial, 'NMPRODUTO');
		geral.searchAndClickGridField('NMPRODFIN', produtoFinal, 'NMPRODUTO');
		geral.clickGrid('NMPRODUTO', produto, descontoProdutoGridId);
		geral.clickEditar();
		geral.clickAndFllField('VRPERDESC', desconto);
		geral.clickSalvar();
		geral.clickOk();
	};

	this.editarTipoDesconto = (nome, situacao, tipoDesconto, desconto) => {
		geral.clickEditar();
		geral.fillField('NMTABDESC', nome);
		geral.selectNative('IDSITTABDESC', situacao);
		geral.selectNative('IDTIPODESC', tipoDesconto);
		if (tipoDesconto == 'Fixo') {
			geral.fillField('VRPERDESC', desconto);
		}
		geral.clickSalvar();
	};

	this.adicionarDescontoProporcional = (produto, qntInicial, qntFinal, desconto) => {
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.clickAdicionar();
		geral.clickAndFllField('QTINIDESC', qntInicial);
		geral.clickAndFllField('QTFINDESC', qntFinal);
		geral.clickAndFllField('VRPERDESC', desconto);
		geral.clickSalvar();
	};

	this.excluirDescontoProporcional = (produto, qntInicial, gridId) => {
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.clickGrid('QTINIDESC', qntInicial, gridId);
		geral.clickExcluir();
		geral.clickSim();
	};
}

module.exports = new tabelaDesconto();
